# vi:fdm=marker fdl=0 syntax=perl:
# $Id: GAUL.pm,v 1.7 2004/05/05 13:09:15 jettero Exp $ 

package AI::GAUL;

use AI::GAUL::Entity;
use AI::GAUL::Population;

use strict;
use warnings;
use Carp;

our $VERSION = q($Revision: 1.7 $); $VERSION =~ s/[^\.\d]//g; $VERSION =~ s/^1\./0.0./;

# export and autoload {{{
require Exporter;
use AutoLoader;
our @ISA = qw(Exporter);
our %EXPORT_TAGS = ( 'all' => [ qw( GA_ELITISM_NULL GA_ELITISM_ONE_PARENT_SURVIVES GA_ELITISM_PARENTS_DIE
	GA_ELITISM_PARENTS_SURVIVE GA_ELITISM_RESCORE_PARENTS GA_ELITISM_UNKNOWN GA_GENESIS_UNKNOWN GA_SCHEME_BALDWIN_ALL
	GA_SCHEME_BALDWIN_CHILDREN GA_SCHEME_BALDWIN_PARENTS GA_SCHEME_DARWIN GA_SCHEME_LAMARCK_ALL
	GA_SCHEME_LAMARCK_CHILDREN GA_SCHEME_LAMARCK_PARENTS

    random_seed
    ga_genesis_bitstring
    ga_bit_get
) ] );

our @EXPORT_OK = ( @{ $EXPORT_TAGS{'all'} } );
our @EXPORT = qw();

sub AUTOLOAD {
    # This AUTOLOAD is used to 'autoload' constants from the constant()
    # XS function.

    my $constname;
    our $AUTOLOAD;
    ($constname = $AUTOLOAD) =~ s/.*:://;
    croak "&AI::GAUL constant not defined" if $constname eq 'constant';
    my ($error, $val) = constant($constname);
    if ($error) { croak "[constant()] $error"; }
	no strict 'refs';
    goto &$AUTOLOAD;
}

require XSLoader;
XSLoader::load('AI::GAUL', $VERSION);

# }}}

1;

__END__
# Below is stub documentation for your module. You'd better edit it!

=head1 NAME

AI::GAUL - An XS wrapper for the most excellent GAUL C library.

=head1 SYNOPSIS

  use AI::GAUL;

=head1 DESCRIPTION

  supz.

=head1 SEE ALSO

    http://gaul.sourceforge.net

    This entire module is really just a wrapper for the most excellent C lib called GAUL.

    Go check out their site.  It has a wonderful array of links.

=head1 AUTHOR

Paul Miller, E<lt>jettero@cpan.orgE<gt>

=head1 COPYRIGHT AND LICENSE

Copyright (C) 2004 by Paul Miller

This library is free software; you can redistribute it and/or modify it under the same terms as GAUL itself.

=cut
