
use ExtUtils::MakeMaker;



WriteMakefile(
    NAME              => 'AI::GAUL',
    VERSION_FROM      => 'GAUL.pm',
    PREREQ_PM         => {},
    LIBS              => ["-L/usr/local/gaul/lib -lgaul -lgaul_util -lm -lslang"],
    INC               => '-I. -I/usr/local/gaul/include -I/usr/include/slang',
    DEFINE            => '',
    OBJECT            => join(" ", map("$_.o", qw(GAUL callbacks))),
);

if  (eval {require ExtUtils::Constant; 1}) {
  # If you edit these definitions to change the constants used by this module,
  # you will need to use the generated const-c.inc and const-xs.inc
  # files to replace their "fallback" counterparts before distributing your
  # changes.
  my @names = map({name=>$_, macro=>1}, (qw( GA_ELITISM_NULL GA_ELITISM_ONE_PARENT_SURVIVES
		 GA_ELITISM_PARENTS_DIE GA_ELITISM_PARENTS_SURVIVE
		 GA_ELITISM_RESCORE_PARENTS GA_ELITISM_UNKNOWN
		 GA_GENESIS_UNKNOWN GA_SCHEME_BALDWIN_ALL
		 GA_SCHEME_BALDWIN_CHILDREN GA_SCHEME_BALDWIN_PARENTS
		 GA_SCHEME_DARWIN GA_SCHEME_LAMARCK_ALL
		 GA_SCHEME_LAMARCK_CHILDREN GA_SCHEME_LAMARCK_PARENTS)));

  $ExtUtils::Constant::macro = 1;

  ExtUtils::Constant::WriteConstants(
                                     NAME         => 'AI::GAUL',
                                     NAMES        => \@names,
                                     DEFAULT_TYPE => 'IV',
                                     C_FILE       => 'const-c.inc',
                                     XS_FILE      => 'const-xs.inc',
                                  );

}
else {
  use File::Copy;
  use File::Spec;
  foreach my $file ('const-c.inc', 'const-xs.inc') {
    my $fallback = File::Spec->catfile('fallback', $file);
    copy ($fallback, $file) or die "Can't copy $fallback to $file: $!";
  }
}
